/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  PayableOverrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../../../common";

export declare namespace OspDataTypes {
  export type PluginStructStruct = {
    isEnable: PromiseOrValue<boolean>;
    tokenAddress: PromiseOrValue<string>;
    amount: PromiseOrValue<BigNumberish>;
  };

  export type PluginStructStructOutput = [boolean, string, BigNumber] & {
    isEnable: boolean;
    tokenAddress: string;
    amount: BigNumber;
  };
}

export interface PluginLogicInterface extends utils.Interface {
  functions: {
    "getPluginInfo(address)": FunctionFragment;
    "pluginPurchased(address,address)": FunctionFragment;
    "purchasePlugin(address)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "getPluginInfo"
      | "pluginPurchased"
      | "purchasePlugin"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "getPluginInfo",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "pluginPurchased",
    values: [PromiseOrValue<string>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "purchasePlugin",
    values: [PromiseOrValue<string>]
  ): string;

  decodeFunctionResult(
    functionFragment: "getPluginInfo",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "pluginPurchased",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "purchasePlugin",
    data: BytesLike
  ): Result;

  events: {};
}

export interface PluginLogic extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: PluginLogicInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    getPluginInfo(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[OspDataTypes.PluginStructStructOutput]>;

    pluginPurchased(
      pluginAddress: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    purchasePlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;
  };

  getPluginInfo(
    pluginAddress: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<OspDataTypes.PluginStructStructOutput>;

  pluginPurchased(
    pluginAddress: PromiseOrValue<string>,
    addr: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  purchasePlugin(
    pluginAddress: PromiseOrValue<string>,
    overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    getPluginInfo(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<OspDataTypes.PluginStructStructOutput>;

    pluginPurchased(
      pluginAddress: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    purchasePlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {};

  estimateGas: {
    getPluginInfo(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    pluginPurchased(
      pluginAddress: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    purchasePlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    getPluginInfo(
      pluginAddress: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    pluginPurchased(
      pluginAddress: PromiseOrValue<string>,
      addr: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    purchasePlugin(
      pluginAddress: PromiseOrValue<string>,
      overrides?: PayableOverrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;
  };
}
